/*
 * Creature.java
 *
 * Created on February 8, 2004, 11:08 PM
 */

package MySimulation;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.*;
import java.util.*;
import javax.swing.JPanel;
import java.awt.geom.*;
/**
 *
 *part code used the Swarm code used code by Duncan Crombie @version 2.02, 21 September 1997
 * @author  Kevin Chiou
 */
/** Creature class adds living organism properties to sprite. */
class Creature extends Sprite {
    final static int MAXSIZE = 5;
    final static int MALE = 2;
    final static int FEMALE = 3;
    final static int DEFAULTDIAMETER = 4;
    
    // added variable for flocking
    final static double repel_distance = 30;   // distnace starts repeling
    final static double ideal_distance = 100;  // ideal distance
    final static double detection_range = 200; // range that boid can "see"
    
    
    static double    BIRTH_RATE = 0.0;
    static double    MFRAT = 0.5;
    static int       PUBERTY_AGE = 100;
    static int       HAPPY_PERIOD = 200; // won't eat other creatures if happy
    int 	     GROWTH_PERIOD = 2000;
    int 	     LIFESPAN = 9999;
    
    
    static Vector    sysEventList = null;
    int              size = 0;
    int              gender = (Math.random() > MFRAT) ? FEMALE : MALE;
    int              age = 0;
    int              last_happy = 0;
    double gx, gy;
    double sx, sy;
    int snode;
    int genable = 0;
    
    // structure i added
    
    Vector neighbor = new Vector();
    Vector enemy = new Vector();
    int MaxChangeAngle = 90;  // limit how much a boid can turn in 1 tick
    int MaxChangeSpeed = 50;  // limit how much a boid change speed in 1 tick
    int ViewAngle= 90;  // what angle can the boid see.
    
    RectBackground rectbg; // consider just use MyGraph
    
    
    
    Creature(JPanel ecoSystem, int sz, Color col, int posX, int posY, RectBackground rect) {
        super(ecoSystem);
        if ((sz >= 1) && (sz <= MAXSIZE))
            size = sz;
        else
            size = MAXSIZE;
        age = (size - 1) * GROWTH_PERIOD;
        feelingGood();
        radius = (DEFAULTDIAMETER + size*2) / 2;
        color = col;
        positionX = posX;
        positionY = posY;
        gx = gy = 0;
        sx = sy = -1;
        
        heading((int)(Math.random() * 359 + 1));
        setSpeed( (int) ( (MAXSPEED * 3 / 4 )* Math.random() + (MAXSPEED / 4)) % MAXSPEED );
        //System.out.println("speed: " + MAXSPEED/size);
        rectbg = rect;
    }
    public void disable_seeking() {genable = 0;}
    
    public void set_seeking(int x, int y) {gx = x; gy = y;genable = 1; sx = sy = -1;}
    
    
    public void tick() {
        age++;
        
        //let sprite do whatever it finds useful first
        
        
        super.tick();
        
        // calculates herding parameters
        //herding(1,5,5);
        herding5();
        clear_neighbor();
        clear_enemy();
        
        
        
        
        
        
        
        
        //old creatures have to expire
       /* if (age > LIFESPAN) {
            sysEventList.addElement(new sysEvent(sysEvent.KILL, this));
        }
        
        //is it time to grow?
        if ((age % GROWTH_PERIOD) == 0)
            sysEventList.addElement(new sysEvent(sysEvent.GROW, this));
        
        */
    }
    
    public void paint(Graphics g) {
        super.paint(g);
    }
    
    public void grow() {
        Image img;
        
        if (size < MAXSIZE) {
            size++;
            radius = (DEFAULTDIAMETER + size*2) / 2;
            //	         setSpeed(MAXSPEED/size);
        }
    }
    public int getRadius()
    {return (DEFAULTDIAMETER + size*2) / 2;
    }
    
    public Color getColor()
    {return color;}
    
    public void add_neighbor(Creature c2) {
        neighbor.add(c2);
        /*
        double dx =   positionX - c2.positionX;
        double dy = positionY - c2.positionY ;
        int newdir = (int) ((Math.atan2(dy,dx) + Math.PI) / (2 * Math.PI) * 360);
        newdir = 360 - newdir + 90;
         
        if (Math.abs(direction - newdir) > ViewAngle) return;  // the culture can't see the neight (can't adjust to what one can't see)
         
        if (dist(c2) < detection_range) {neighbor.add(c2);}
         */
    }
    
    public void clear_neighbor()
    {neighbor.clear();}
    
    public void add_enemy(Creature c2)
    { if (dist(c2) < detection_range)enemy.add(c2);}
    
    public void clear_enemy()
    {enemy.clear();}
    
    
    
    public Point normalizePoint(Point p, double n) {
        if (sizeOfPoint(p) == 0.0) return p;
        else {
            double weight = n / sizeOfPoint(p);
            return new Point((int)(p.x * weight), (int)(p.y * weight));
        }
    }
    
    public Point sumPoints(Point p1, double w1, Point p2, double w2) {
        return new Point((int)(w1*p1.x + w2*p2.x), (int)(w1*p1.y + w2*p2.y));
    }
    
    public Point getPosition() {
        return new Point((int) positionX, (int) positionY);
    }
    
    
    
    public void herding5() {
        // converts current direction and speed to a vector
        Point cvector = new Point(vectorX(), vectorY());
        
        Point v1; // = Cohesion();
        Point v2; //= Separation();
        Point v3; //= Alignment();
        Point v4; // = heading();
        Point v5; // = repeal different color;
        Point v6; // repel obstacle
        
        // Cohesion Separation and Alignment
        Creature c2;
        Point pc = new Point(0,0);  // for cohesion
        Point c = new Point(0,0);      // for separation
        Point al = new Point(0, 0); // for alignment
        //int acounter = 0; // for alignment
        int tspeed = 0;  // for alignment
        int total = 0;
        
        int counter = 0;
        int scounter = 0; // for separation force count
        
        
        for (Enumeration e = neighbor.elements(); e.hasMoreElements();) {
            c2 = (Creature) e.nextElement();
            
            if ((c2 != this ) && (!rectbg.checkintersectsLine(getX(), getY(),c2.getX(), c2.getY()) )) { // make sure can see the neighbors
                
                int distance = dist(c2);
                Point dirc2 = new Point((int) (c2.positionX - positionX), (int) (c2.positionY- positionY));
                int angleofc2 = (int)  (180.0/Math.PI * Math.atan2(dirc2.getY(), dirc2.getX()));
                angleofc2 = (angleofc2 - direction + 360) % 360;
                
                total++;
                if ( (Math.abs(direction - angleofc2) % 180) < ViewAngle) {
                    if (distance >= 0 && distance <= detection_range) {
                        if (distance >= repel_distance) {
                            pc.setLocation( pc.getX()+ c2.positionX, pc.getY()+ c2.positionY);
                            
                            
                            counter++;
                        }
                        else {
                            Point vector2 = new Point( (int) (positionX - c2.positionX), (int) (positionY - c2.positionY)); // use to calculate speed change
                            
                            //normalizePoint(vector2, 1);
                            double rate = Math.pow( (double) (repel_distance - distance)/repel_distance, 2) * MAXSPEED ;
                            normalizePoint(vector2, rate);
                            c.setLocation(c.getX() + vector2.getX(), c.getY() + vector2.getY());
                            scounter++;
                        }
                        
                        
                        // calculate alignment
                        {
                            // calculate speed change for alignment
                            Point vector2 = new Point( (int) c2.vectorX(), (int) c2.vectorY()); // use to calculate speed change
                            //double rate = Math.pow( (double) ( (distance - repel_distance) / (detection_range - repel_distance)), 2) * MAXSPEED ;
                            
                            al = sumPoints(al,1, vector2,1);
                        }
                        
                        
                        if (distance >= ideal_distance) // catch up
                        {
                            //double rate = Math.pow( (double) ( (distance - repel_distance) / (detection_range - repel_distance)), 1) * (MAXSPEED - c2.speed);
                            tspeed += MAXSPEED * .7 ;
                        }
                        else tspeed +=  MAXSPEED * .6 ;  
                        
                        
                    }
                    else tspeed += MAXSPEED / 2; // slow down
                }
                else {                    
                    tspeed += MAXSPEED;                
                }              
                
                
                
            }
            
            
        }
        // cohension
        if (counter == 0) v1 = new Point(0,0);
        else{
            pc.setLocation( pc.getX()/counter, pc.getY() / counter);
            pc.setLocation( pc.getX() - positionX, pc.getY() - positionY);
            pc.setLocation( pc.getX() / 10 , pc.getY()/ 10);
            
            v1 = pc;
        }
        
        
        
        // calculates speed change
        // 2 factors, alignment and separation
      //  if (scounter != 0) {c.setLocation(c.getX() / scounter, c.getY() / scounter); changeSpeed( (int) sizeOfPoint(c));}
        if ((total) != 0) changeSpeed(tspeed/(total));
        
        al.setLocation(al.getX() / 50, al.getY() / 50);
        
        
        
        v2 = normalizePoint(c, 50); // separation
        
        // homing
        
        if ((genable == 1) && (scounter < 3)){
            
            if (sx == -1 || sy == -1) // no sub goal yet
            {
                snode = rectbg.findClosestNodeInSight(getX(), getY()); // find closest node to the current location                                                  
            }
            
            {
                // Point2D pt2 = new Point2D.Double(sx,sy);
                //Point2D pt1 = new Point2D.Double(getX(), getY());
                
                //if (pt2.distance(pt1) <= 30)
                
                snode = rectbg.getNextNode(getX(), getY());
                if (snode == -1) {
                    sx = gx;
                    sy = gy;
                    //sx = sy = 0;
                }
                else {
                    
                    sx =  (int) rectbg.getNodeX(snode);
                    sy =  (int) rectbg.getNodeY(snode);
                    
                   
                    
                }
                
                
                
            }
            
            
            
            
            double dx = sx-positionX;
            double dy = sy-positionY ;
            
            v4 = normalizePoint( new Point((int) dx,(int) dy), 50);
        }
        else v4 = new Point(0,0);
        
        /* calculates reple force for different color*/
        Point repel = new Point();
        
        for (Enumeration e = enemy.elements(); e.hasMoreElements();) {
            c2 = (Creature) e.nextElement();
            
            if (c2 != this ) {
                int distance = dist(c2);
                if (distance >= 0 && distance <= (detection_range / 2)) {
                    Point vector2 = new Point( (int) (positionX - c2.positionX), (int) (positionY - c2.positionY));
                    
                    //normalizePoint(vector2, 1);
                    //double rate = Math.pow( (double) (repel_distance - distance)/repel_distance, 2) *MAXSPEED ;
                    //normalizePoint(vector2, rate);
                    repel.setLocation(repel.getX() + vector2.getX(), repel.getY() + vector2.getY());
                }
                
            }
        }
        repel.setLocation(repel.getX() / 8, repel.getY() / 8);
        v5 = repel;
        
        // v6 is obstacle repel
        // get a list of obstacles in the viewing range
        Vector obstacles = rectbg.getCloseRect((int) getX(), (int) getY(), (int) detection_range / 2);
        Point2D ob;
        
        v6 = new Point(0,0);
        for (Enumeration e = obstacles.elements(); e.hasMoreElements();) {
            ob = (Point2D) e.nextElement();            
            Point vector2 = new Point( (int) (positionX - ob.getX()), (int) (positionY - ob.getY()));
            int distance = (int) vector2.distance(0,0);
              normalizePoint(vector2, 1);
              double rate = Math.pow( (double) (detection_range /2.0 - distance)/ (detection_range/2.0 ), 1) * MAXSPEED / 2;
              normalizePoint(vector2, rate);
            v6.setLocation(v6.getX() + vector2.getX(), v6.getY() + vector2.getY());
        }
        //System.out.println(obstacles.size());
        v6.setLocation(v6.getX() / 10 , v6.getY() / 10);
        
        
        //al.setLocation(al.getX(), al.getY() / 20);
        v3 = al; // vector 3 is for alignment
        
        cvector = sumPoints(cvector,1, v1,1);
        cvector = sumPoints(cvector,1, v2,1);
        cvector = sumPoints(cvector,1, v3,1);
        cvector = sumPoints(cvector,1, v4,1);
        cvector = sumPoints(cvector,1, v5,1);
        //cvector = sumPoints(cvector,1, v6,1);
        
        vector.clear();
        vector.add(v1);
        vector.add(v2);
        vector.add(v3);
        vector.add(v4);
        vector.add(v5);
        //vector.add(v6);
        
        VectorToPolar(cvector.getX(), cvector.getY());
        
    }
   
    public void changeSpeed(int newspeed) {
        int speedchange = newspeed - (int) speed;
        if (speedchange > 0) speed = speed + Math.min(MaxChangeSpeed, speedchange);
        else speed = speed = speed - Math.min(MaxChangeSpeed, -speedchange);
        if (speed < MAXSPEED / 10) speed =MAXSPEED / 10;
    }
    public void VectorToPolar(Point pt)
    {VectorToPolar(pt.getX(), pt.getY());
    }
    
    public void VectorToPolar(double x, double y)
    // this component coverts component in x and y back to polar components
    {
        Point p = new Point((int) x,(int) y);
        int targetTheta = (int)  (180.0/Math.PI * Math.atan2(y, x ));
        
        int iHeading = (targetTheta + 360 ) % 360; // angle for Bird to steer towards
        int left = (iHeading - direction +360) % 360;
        int right = (direction - iHeading +360) % 360;
        int iChange = 0;
        
        if (left < right)
            iChange = Math.min(MaxChangeAngle, left);
        else
            iChange = -Math.min(MaxChangeAngle, right);
        //System.out.println(targetTheta + "," + direction + "," + iChange);
        direction= (direction + iChange + 360) % 360;
    }
    
    //////////////// end herding 4 ///////////////////////
    
    public void repel(Creature c2)
    // boid will try to avoid creature in the enemy list.
    {
        double dx =   positionX - c2.positionX;
        double dy = positionY - c2.positionY ;
        
        int newdir = (int) ((Math.atan2(dy,dx) + Math.PI) / (2 * Math.PI) * 360);
        
        
        newdir = (newdir + 180) % 360;
        if ( Math.abs(newdir - direction) < 180){
            direction = (1* direction + 9* newdir)  / 10;
            speed = (7* c2.speed + 3* speed) /10;
        }
        
    }
    public int dist(Creature c2) {
        double dx = positionX - c2.positionX;
        double dy = positionY - c2.positionY;
        
        return (int) Math.abs((Math.sqrt( Math.pow(dx,2) + Math.pow(dy,2))));
    }
    
    public void changeColor() {
        color = new Color((int) (Math.random() * 255),(int) (Math.random() * 255),(int) (Math.random() * 255));
        
    }
    
    public void eat(Creature victim) {
        color = new Color((int)((color.getRed() + victim.color.getRed()) / 2),
        (int)((color.getGreen() + victim.color.getGreen()) / 2),
        (int)((color.getBlue() + victim.color.getBlue()) / 2));
        sysEventList.addElement(new sysEvent(sysEvent.KILL, victim));
        feelingGood(); //food is good
    }
    
    public boolean isHungry() {
        //bigger creatures get hungry faster
        return ((age - last_happy) > (HAPPY_PERIOD * (MAXSIZE - size + 1)));
    }
    
    public boolean isAdult() {
        return (age > PUBERTY_AGE);
    }
    
    public void justGaveBirth() {
        //    	 feelingGood(); //giving birth is good
    }
    
    public void feelingGood() {
        last_happy = age;
    }
}